<?php

namespace App\Filament\Imports;

use App\Models\StickerStructureDetail;
use Filament\Actions\Imports\ImportColumn;
use Filament\Actions\Imports\Importer;
use Filament\Actions\Imports\Models\Import;

class StickerStructureDetailImporter extends Importer
{
    protected static ?string $model = StickerStructureDetail::class;

    public static function getColumns(): array
    {
        return [
            ImportColumn::make('sticker_id'),
            ImportColumn::make('sticker_width'),
            ImportColumn::make('sticker_height'),
            ImportColumn::make('sticker_lmargin'),
            ImportColumn::make('sticker_rmargin'),
            ImportColumn::make('sticker_tmargin'),
            ImportColumn::make('sticker_bmargin'),
            ImportColumn::make('created_by'),
            ImportColumn::make('updated_by'),
        ];
    }

    public function resolveRecord(): ?StickerStructureDetail
    {
        // return StickerStructureDetail::firstOrNew([
        //     // Update existing records, matching them by `$this->data['column_name']`
        //     'email' => $this->data['email'],
        // ]);

        return new StickerStructureDetail();
    }

    public static function getCompletedNotificationBody(Import $import): string
    {
        $body = 'Your sticker structure detail import has completed and ' . number_format($import->successful_rows) . ' ' . str('row')->plural($import->successful_rows) . ' imported.';

        if ($failedRowsCount = $import->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to import.';
        }

        return $body;
    }
}
